#include <stdlib.h>
#include <stdio.h>
#include <cutil_inline.h>
#include <cuda_runtime.h>

__constant__ float cFloat1;
__constant__ float cFloat2[3];

int main(int argc, const char **argv)
{
	// try to get symbol address (works fine)
	void* addr;
	cutilSafeCall(cudaGetSymbolAddress(&addr, cFloat1));
	cutilSafeCall(cudaThreadSynchronize());
	printf("ok1\n");
	cutilSafeCall(cudaGetSymbolAddress(&addr, cFloat2));
	cutilSafeCall(cudaThreadSynchronize());
	printf("ok2\n");

	// try to get symbol size (fails with CUDA 3.0)
	size_t symbolsize = 0;
	cutilSafeCall(cudaGetSymbolSize(&symbolsize, cFloat1));
	cutilSafeCall(cudaThreadSynchronize());
	printf("size1: %i\n", symbolsize);
	cutilSafeCall(cudaGetSymbolSize(&symbolsize, cFloat2));
	cutilSafeCall(cudaThreadSynchronize());
	printf("size1: %i\n", symbolsize);
}